//+------------------------------------------------------------------+ 
//|                                        3_Level_ZZ_Semafor.mq4    | 
//+------------------------------------------------------------------+ 
//| 3_Level_ZZ_Semafor_TRO_MODIFIED_VERSION                          |
//| MODIFIED BY AVERY T. HORTON, JR. AKA THERUMPLEDONE@GMAIL.COM     |
//| I am NOT the ORIGINAL author 
//  and I am not claiming authorship of this indicator. 
//  All I did was modify it. I hope you find my modifications useful.|
//|                                                                  |
// BUTCHERED BY BREDIN OF INSANITY INDUSTRIES
//+------------------------------------------------------------------+
 
#property copyright "asystem2000" 
#property link      "asystem2000@yandex.ru" 

#property indicator_chart_window 
#property indicator_buffers 6
#property indicator_color1 CornflowerBlue 
#property indicator_color2 CornflowerBlue
#property indicator_color3 Yellow
#property indicator_color4 Yellow
#property indicator_color5 White
#property indicator_color6 White
//+--------- TRO MODIFICATION ---------------------------------------+ 

extern bool cpusaver = true; // II MOD

extern bool   ShowTrendlines  = false; 

extern string myUpperTrendLineName  = "UpperTrendLine001";
extern color  myUpperTrendLineColor = Yellow; 
extern int    myUpperTrendLineStyle = STYLE_SOLID;
extern int    myUpperTrendLineWidth = 2;
extern string myUpperSoundFile      = "ahooga.wav";

extern string myLowerTrendLineName  = "LowerTrendLine001";
extern color  myLowerTrendLineColor = Yellow; 
extern int    myLowerTrendLineStyle = STYLE_SOLID;
extern int    myLowerTrendLineWidth = 2;
extern string myLowerSoundFile      = "siren.wav";


extern int    myThreshold      = 1;

extern bool   SoundAlert    = false ;
extern string alertwav       = "Xsound.wav";
extern bool   MailAlert     = false ;
extern bool   ShowComment   = false ; 
extern int    myBars         = 100 ;
extern int    NumComments    = 5 ;


//--------------- Insanity Industries Modification This block
extern bool   ShowINPLAY = false;
extern int    INPLAYcorner = 0;
extern int    INPLAYx = 250;
extern int    INPLAYy = 30;
extern string INPLAYFont  = "Arial Bold" ;
extern int    INPLAYFontSize = 20 ;
extern color  INPLAYHiColor = LimeGreen;
extern color  INPLAYLoColor = Red;
extern bool   DropShadows = false;
extern int    ShadowDepth = 2;
extern color  border_color = SteelBlue;
extern color  cell_color   = MintCream;
extern color  shadow_color = DarkGray;


//---- input parameters 
extern double Period1=5; 
extern double Period2=12; 
extern double Period3=32; 
extern string   Dev_Step_1="5,3";
extern string   Dev_Step_2="5,5";
extern string   Dev_Step_3="5,5";
extern int Symbol_1_Kod=121;
extern int Symbol_2_Kod=121;
extern int Symbol_3_Kod=183;

extern int Symbol_1_Size=0;
extern int Symbol_2_Size=0;
extern int Symbol_3_Size=0;


//---- buffers 
double FP_BuferUp[];
double FP_BuferDn[]; 
double NP_BuferUp[];
double NP_BuferDn[]; 
double HP_BuferUp[];
double HP_BuferDn[]; 

int F_Period;
int N_Period;
int H_Period;
int Dev1;
int Stp1;
int Dev2;
int Stp2;
int Dev3;
int Stp3;
//+--------- TRO MODIFICATION ---------------------------------------+ 
string symbol, tChartPeriod,  tShortName ;  
int    digits, period  ; 

bool Trigger1,  Trigger2,  Trigger3 ;

int OldBars = -1 ;

color tColor = Yellow ;

int i, j, k, tltop, tlbot;
 
string Messages[26], theMessage, space ;

bool roll ;

double point ;
double upperTL[2], lowerTL[2];
double UpperTrendLinePrice, LowerTrendLinePrice, UpperLimit, LowerLimit, xThreshold;


datetime upperTLtime[2], lowerTLtime[2];
 
string TAG = "3lzz", OBJ001, OBJ002 ;  
 
 
//+------------------------------------------------------------------+ 
int init() 
  { 
//+--------- TRO MODIFICATION ---------------------------------------+  
   period       = Period() ;     
   tChartPeriod =  TimeFrameToString(period) ;
   symbol       =  Symbol() ;
   digits       =  Digits ;
   point        =  Point ;   
   
   if(digits == 5 || digits == 3) { digits = digits - 1 ; point = point * 10 ; }   
   
   
   tShortName = "tbb"+ symbol + tChartPeriod  ;
    
   xThreshold   = myThreshold * point ;   
  
 
   OBJ001       = TAG + "001";
   OBJ002       = TAG + "002";  
  
// ---------     
  
  
   if (Period1>0) F_Period=MathCeil(Period1*Period()); else F_Period=0; 
   if (Period2>0) N_Period=MathCeil(Period2*Period()); else N_Period=0; 
   if (Period3>0) H_Period=MathCeil(Period3*Period()); else H_Period=0; 
   
//----  1  
   if (Period1>0)
   {
   SetIndexStyle(0,DRAW_ARROW,0,Symbol_1_Size); 
   SetIndexArrow(0,Symbol_1_Kod); 
   SetIndexBuffer(0,FP_BuferUp); 
   SetIndexEmptyValue(0,0.0); 
   
   SetIndexStyle(1,DRAW_ARROW,0,Symbol_1_Size); 
   SetIndexArrow(1,Symbol_1_Kod); 
   SetIndexBuffer(1,FP_BuferDn); 
   SetIndexEmptyValue(1,0.0); 
   }
   
//----  2  
   if (Period2>0)
   {
   SetIndexStyle(2,DRAW_ARROW,0,Symbol_2_Size); 
   SetIndexArrow(2,Symbol_2_Kod); 
   SetIndexBuffer(2,NP_BuferUp); 
   SetIndexEmptyValue(2,0.0); 
   
   SetIndexStyle(3,DRAW_ARROW,0,Symbol_2_Size); 
   SetIndexArrow(3,Symbol_2_Kod); 
   SetIndexBuffer(3,NP_BuferDn); 
   SetIndexEmptyValue(3,0.0); 
   }
//----  3  
   if (Period3>0)
   {
   SetIndexStyle(4,DRAW_ARROW,0,Symbol_3_Size); 
   SetIndexArrow(4,Symbol_3_Kod); 
   SetIndexBuffer(4,HP_BuferUp); 
   SetIndexEmptyValue(4,0.0); 

   SetIndexStyle(5,DRAW_ARROW,0,Symbol_3_Size); 
   SetIndexArrow(5,Symbol_3_Kod); 
   SetIndexBuffer(5,HP_BuferDn); 
   SetIndexEmptyValue(5,0.0); 
   }
//     
   int CDev=0;
   int CSt=0;
   int Mass[]; 
   int C=0;  
   if (IntFromStr(Dev_Step_1,C, Mass)==1) 
      {
        Stp1=Mass[1];
        Dev1=Mass[0];
      }
   
   if (IntFromStr(Dev_Step_2,C, Mass)==1)
      {
        Stp2=Mass[1];
        Dev2=Mass[0];
      }      
   
   
   if (IntFromStr(Dev_Step_3,C, Mass)==1)
      {
        Stp3=Mass[1];
        Dev3=Mass[0];
      }      
   return(0); 
  } 

//+------------------------------------------------------------------+

void ObDeleteObjectsByPrefix(string Prefix)
{
   int L = StringLen(Prefix);
   int i = 0; 
   while(i < ObjectsTotal())
     {
       string ObjName = ObjectName(i);
       if(StringSubstr(ObjName, 0, L) != Prefix) 
         { 
           i++; 
           continue;
         }
       ObjectDelete(ObjName);
     }
}
    
//+------------------------------------------------------------------+
int deinit()
{
   Comment("") ;
       
   ObDeleteObjectsByPrefix(TAG);  
   
   TRO() ;
   
   return(0);
}

//+------------------------------------------------------------------+ 
int start() 
  { 
  

//+--------- TRO MODIFICATION ---------------------------------------+   
   if( Bars != OldBars ) { Trigger1 = True ; Trigger2 = True ; Trigger3 = True ;}
   
     
   if (Period1>0) CountZZ(FP_BuferUp,FP_BuferDn,Period1,Dev1,Stp1);
   if (Period2>0) CountZZ(NP_BuferUp,NP_BuferDn,Period2,Dev2,Stp2);
   if (Period3>0) CountZZ(HP_BuferUp,HP_BuferDn,Period3,Dev3,Stp3);
   
   
//+--------- TRO MODIFICATION ---------------------------------------+  
      
      if ( Trigger1 ) 
      { 
        if( FP_BuferUp[0] != 0 ) { Trigger1 = False ; if(SoundAlert) {PlaySound(alertwav);}}//Alert(symbol," ", tChartPeriod, " Dip "+ DoubleToStr(Close[0] ,digits)); } }
        if( FP_BuferDn[0] != 0 ) { Trigger1 = False ; if(SoundAlert) {PlaySound(alertwav);}}//Alert(symbol," ", tChartPeriod, " Tip "+ DoubleToStr(Close[0] ,digits)); } }
      }
      
      if ( Trigger1 ) 
      { 
        if( FP_BuferUp[0] != 0 ) { Trigger1 = False ; if(MailAlert) {SendMail(symbol+" "+ tChartPeriod+ " Dip "+ DoubleToStr(Close[0],digits),symbol+" "+ tChartPeriod+ " Tip "+ DoubleToStr(Close[0],digits));} }
        if( FP_BuferDn[0] != 0 ) { Trigger1 = False ; if(MailAlert) {SendMail(symbol+" "+ tChartPeriod+ " Tip "+ DoubleToStr(Close[0],digits),symbol+" "+ tChartPeriod+ " Dip "+ DoubleToStr(Close[0],digits));} }
      }
      
      
      if ( Trigger2 ) 
      {
        if( NP_BuferUp[0] != 0 ) { Trigger2 = False ; if(SoundAlert) {PlaySound(alertwav);}}//Alert(symbol," ", tChartPeriod, " N2 Low "+ DoubleToStr(Close[0] ,digits)); } }
        if( NP_BuferDn[0] != 0 ) { Trigger2 = False ; if(SoundAlert) {PlaySound(alertwav);}}//Alert(symbol," ", tChartPeriod, " N2 High "+ DoubleToStr(Close[0] ,digits)); } }
      }
      
      if ( Trigger2 ) 
      {
        if( NP_BuferUp[0] != 0 ) { Trigger2 = False ; if(MailAlert) {SendMail(symbol+" "+ tChartPeriod+ " N2 Low "+ DoubleToStr(Close[0],digits),symbol+" "+ tChartPeriod+ " Tip "+ DoubleToStr(Close[0],digits));} }
        if( NP_BuferDn[0] != 0 ) { Trigger2 = False ; if(MailAlert) {SendMail(symbol+" "+ tChartPeriod+ " N2 High "+ DoubleToStr(Close[0],digits),symbol+" "+ tChartPeriod+ " Dip "+ DoubleToStr(Close[0],digits));} }
      }
      
      if ( Trigger3 ) 
      {     
        if( HP_BuferUp[0] != 0 ) { Trigger3 = False ; if(SoundAlert) {PlaySound(alertwav);}}//Alert(symbol," ", tChartPeriod, " N3 Low "+ DoubleToStr(Close[0] ,digits)); } }
        if( HP_BuferDn[0] != 0 ) { Trigger3 = False ; if(SoundAlert) {PlaySound(alertwav);}}//Alert(symbol," ", tChartPeriod, " N3 High "+ DoubleToStr(Close[0] ,digits)); } }
      }
      
      if ( Trigger3 ) 
      {     
        if( HP_BuferUp[0] != 0 ) { Trigger3 = False ; if(MailAlert) {SendMail(symbol+" "+ tChartPeriod+ " N3 Low "+ DoubleToStr(Close[0],digits),symbol+" "+ tChartPeriod+ " Tip "+ DoubleToStr(Close[0],digits));} }
        if( HP_BuferDn[0] != 0 ) { Trigger3 = False ; if(MailAlert) {SendMail(symbol+" "+ tChartPeriod+ " N3 High "+ DoubleToStr(Close[0],digits),symbol+" "+ tChartPeriod+ " Dip "+ DoubleToStr(Close[0],digits));} }
      }

    
   if(ShowComment)
   {
      k = 0 ;
      theMessage = "";
      for( i=0; i<26; i++ ) { Messages[i] = "" ; }
      
   for( j=myBars; j>=0; j-- )
   {   
      while(true)
      {
         if( HP_BuferUp[j] != 0 ) {DoRollMsg( TimeToStr(Time[j]) + " bot 3 " ) ; break ; }
         if( HP_BuferDn[j] != 0 ) {DoRollMsg( TimeToStr(Time[j]) + " top 3 " ) ; break ; }         
         
         if( NP_BuferUp[j] != 0 ) {DoRollMsg( TimeToStr(Time[j]) + " bot 2 " ) ; break ; }
         if( NP_BuferDn[j] != 0 ) {DoRollMsg( TimeToStr(Time[j]) + " top 2 " ) ; break ; }         
         
         if( FP_BuferUp[j] != 0 ) {DoRollMsg( TimeToStr(Time[j]) + " bot 1 " ) ; break ; }
         if( FP_BuferDn[j] != 0 ) {DoRollMsg( TimeToStr(Time[j]) + " top 1 " ) ; break ; }
         break ;
      } // while
   } // for j
   
         
      for( i=0; i<NumComments; i++ )
      {
         if(Messages[i] != "" )
         {
            theMessage = theMessage + "\n" +Messages[i] ;
         }
         else { break ; }
      } // for i
 
      Comment(theMessage) ;
   
   } // if



  

   if(ShowTrendlines)
   {
      tltop = 0 ; 
      tlbot = 0 ;
   
   for( j=0; j<1000; j++ )
   {   
      while(true)
      {
         if( HP_BuferUp[j] != 0 && tlbot < 2 ) {lowerTLtime[tlbot] = Time[j] ; lowerTL[tlbot] = HP_BuferUp[j] ; tlbot = tlbot + 1 ; break ; }
         if( HP_BuferDn[j] != 0 && tltop < 2 ) {upperTLtime[tltop] = Time[j] ; upperTL[tltop] = HP_BuferDn[j] ; tltop = tltop + 1 ; break ; }         
         
         if( NP_BuferUp[j] != 0 && tlbot < 2 ) {lowerTLtime[tlbot] = Time[j] ; lowerTL[tlbot] = NP_BuferUp[j] ; tlbot = tlbot + 1 ; break ; }
         if( NP_BuferDn[j] != 0 && tltop < 2 ) {upperTLtime[tltop] = Time[j] ; upperTL[tltop] = NP_BuferDn[j] ; tltop = tltop + 1 ; break ; }         
         
         if( FP_BuferUp[j] != 0 && tlbot < 2 ) {lowerTLtime[tlbot] = Time[j] ; lowerTL[tlbot] = FP_BuferUp[j] ; tlbot = tlbot + 1 ; break ; }
         if( FP_BuferDn[j] != 0 && tltop < 2 ) {upperTLtime[tltop] = Time[j] ; upperTL[tltop] = FP_BuferDn[j] ; tltop = tltop + 1 ; break ; }
         break ;
      } // while
      
      if( tlbot >=2 && tltop >= 2 ) { break ;  }
   } // for j   
      

   DrawPriceTrendLines(OBJ001, upperTLtime[1], upperTLtime[0], upperTL[1], 
                        upperTL[0], myUpperTrendLineColor, myUpperTrendLineStyle, myUpperTrendLineWidth) ;

   DrawPriceTrendLines(OBJ002, lowerTLtime[1], lowerTLtime[0], lowerTL[1], 
                        lowerTL[0], myLowerTrendLineColor, myLowerTrendLineStyle, myLowerTrendLineWidth) ;



      UpperTrendLinePrice = ObjectGetValueByShift(OBJ001, 0);
      
      LowerTrendLinePrice = ObjectGetValueByShift(OBJ002, 0);
           
      UpperLimit = Ask + xThreshold ;
      LowerLimit = Bid - xThreshold ;


   if(SoundAlert)
   {      
      if( UpperTrendLinePrice >= LowerLimit && UpperTrendLinePrice <= UpperLimit )
      {
         PlaySound(myUpperSoundFile);
      } 
      
      if( LowerTrendLinePrice >= LowerLimit && LowerTrendLinePrice <= UpperLimit )
      {
         PlaySound(myLowerSoundFile);
      } 
   } // if 
   
 
   } // if 
    
    
   OldBars = Bars ;   

//+--------- TRO MODIFICATION ---------------------------------------+        

   if (Period() == PERIOD_H1 && ShowINPLAY) DrawInPlay();
//   if (ShowINPLAY)
          
   return(0);
}

//+--------- TRO MODIFICATION ---------------------------------------+  

string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN";
   }
   return(tfs);
}

//+------------------------------------------------------------------+ 
//  
//int Take



//+------------------------------------------------------------------+ 
//|                           | 
//+------------------------------------------------------------------+  
int CountZZ( double& ExtMapBuffer[], double& ExtMapBuffer2[], int ExtDepth, int ExtDeviation, int ExtBackstep )
  {
   int    shift, back,lasthighpos,lastlowpos;
   double val,res;
   double curlow,curhigh,lasthigh,lastlow;
   int count = Bars-ExtDepth;
   if(cpusaver) count = MathMin(Bars-ExtDepth,ExtDepth*3);

   for(shift=count; shift>=0; shift--)
     {
      val=Low[Lowest(NULL,0,MODE_LOW,ExtDepth,shift)];
      if(val==lastlow) val=0.0;
      else 
        { 
         lastlow=val; 
         if((Low[shift]-val)>(ExtDeviation*Point)) val=0.0;
         else
           {
            for(back=1; back<=ExtBackstep; back++)
              {
               res=ExtMapBuffer[shift+back];
               if((res!=0)&&(res>val)) ExtMapBuffer[shift+back]=0.0; 
              }
           }
        } 
        
          ExtMapBuffer[shift]=val;
      //--- high
      val=High[Highest(NULL,0,MODE_HIGH,ExtDepth,shift)];
      if(val==lasthigh) val=0.0;
      else 
        {
         lasthigh=val;
         if((val-High[shift])>(ExtDeviation*Point)) val=0.0;
         else
           {
            for(back=1; back<=ExtBackstep; back++)
              {
               res=ExtMapBuffer2[shift+back];
               if((res!=0)&&(res<val)) ExtMapBuffer2[shift+back]=0.0; 
              } 
           }
        }
      ExtMapBuffer2[shift]=val;
     }
   // final cutting 
   lasthigh=-1; lasthighpos=-1;
   lastlow=-1;  lastlowpos=-1;

   for(shift=count; shift>=0; shift--)
     {
      curlow=ExtMapBuffer[shift];
      curhigh=ExtMapBuffer2[shift];
      if((curlow==0)&&(curhigh==0)) continue;
      //---
      if(curhigh!=0)
        {
         if(lasthigh>0) 
           {
            if(lasthigh<curhigh) ExtMapBuffer2[lasthighpos]=0;
            else ExtMapBuffer2[shift]=0;
           }
         //---
         if(lasthigh<curhigh || lasthigh<0)
           {
            lasthigh=curhigh;
            lasthighpos=shift;
           }
         lastlow=-1;
        }
      //----
      if(curlow!=0)
        {
         if(lastlow>0)
           {
            if(lastlow>curlow) ExtMapBuffer[lastlowpos]=0;
            else ExtMapBuffer[shift]=0;
           }
         //---
         if((curlow<lastlow)||(lastlow<0))
           {
            lastlow=curlow;
            lastlowpos=shift;
           } 
         lasthigh=-1;
        }
     }
  
   for(shift=Bars-1; shift>=0; shift--)
     {
      if(shift>=count) ExtMapBuffer[shift]=0.0;
      else
        {
         res=ExtMapBuffer2[shift];
         if(res!=0.0) ExtMapBuffer2[shift]=res;
        }
     }
 }

//+------------------------------------------------------------------+   
int Str2Massive(string VStr, int& M_Count, int& VMass[])
  {
    int val=StrToInteger( VStr);
    if (val>0)
       {
         M_Count++;
         int mc=ArrayResize(VMass,M_Count);
         if (mc==0)return(-1);
          VMass[M_Count-1]=val;
         return(1);
       }
    else return(0);    
  } 
  

//+------------------------------------------------------------------+   
int IntFromStr(string ValStr,int& M_Count, int& VMass[])
  {
    
    if (StringLen(ValStr)==0) return(-1);
    string SS=ValStr;
    int NP=0; 
    string CS;
    M_Count=0;
    ArrayResize(VMass,M_Count);
    while (StringLen(SS)>0)
      {
            NP=StringFind(SS,",");
            if (NP>0)
               {
                 CS=StringSubstr(SS,0,NP);
                 SS=StringSubstr(SS,NP+1,StringLen(SS));  
               }
               else
               {
                 if (StringLen(SS)>0)
                    {
                      CS=SS;
                      SS="";
                    }
               }
            if (Str2Massive(CS,M_Count,VMass)==0) 
               {
                 return(-2);
               }
      }
    return(1);    
  }
  



//+------------------------------------------------------------------+

string fFill(string filled, int f ) 
{
   string FILLED ;
   
   FILLED = StringSubstr(filled + "                                         ",0,f) ;
   
return(FILLED);
}

//+------------------------------------------------------------------+

void DoRollMsg( string msg ) 
{    

if(msg != "" )
{
   roll = true ;

   for( int m=23; m>=0 ; m-- )
   {
      Messages[m+1] = Messages[m];
   } // for
   
   Messages[0] = fFill(msg, 30 ) ;  
    
}// if

} // void
//+------------------------------------------------------------------+
 

void DrawPriceTrendLines(string objname, datetime x1, datetime x2, double y1, 
                        double y2, color lineColor, int style, int width)
  {
    
   ObjectDelete(objname);
   ObjectCreate(objname, OBJ_TREND, 0, x1, y1, x2, y2, 0, 0);
   ObjectSet(objname, OBJPROP_RAY, true);
 
   ObjectSet(objname, OBJPROP_COLOR, lineColor);
   ObjectSet(objname, OBJPROP_STYLE, style);
   ObjectSet(objname, OBJPROP_WIDTH, width);
  }
 

//+------------------------------------------------------------------+
void TRO()
{   
   
    
}

bool InPlay(double& buffer[])
{
   if(buffer[0] > point) return(1);
   if(buffer[1] > point) return(1);
   return(0);
}

void DrawInPlay()
{
   bool Up3,Dn3,Up2,Dn2,Up1,Dn1;
   string sem, msg;
   color msgcolor;
   msg = "IN PLAY";
   Up3 = InPlay(HP_BuferUp);
   Up2 = InPlay(NP_BuferUp);
   Up1 = InPlay(FP_BuferUp);
   Dn3 = InPlay(HP_BuferDn);
   Dn2 = InPlay(NP_BuferDn);
   Dn1 = InPlay(FP_BuferDn);
   string label;
   
   if(!Up1 && !Up2 && !Up3 && !Dn1 && !Dn2 && !Dn3)
   {
      ObDeleteObjectsByPrefix(TAG);
      return;
   }
   
   if(Up1 || Up2 || Up3) msgcolor = INPLAYLoColor;
   if(Up1) sem = CharToStr(Symbol_1_Kod);
   if(Up2) sem = CharToStr(Symbol_2_Kod);
   if(Up3) sem = CharToStr(Symbol_3_Kod);

   if(Dn1 || Dn2 || Dn3) msgcolor = INPLAYHiColor;
   if(Dn1) sem = CharToStr(Symbol_1_Kod);
   if(Dn2) sem = CharToStr(Symbol_2_Kod);
   if(Dn3) sem = CharToStr(Symbol_3_Kod);

   if((Dn1 || Dn2 || Dn3) && (Up1 || Up2 || Up3))
   {
      msgcolor = CLR_NONE;
      if(Up1 || Dn1) sem = CharToStr(Symbol_1_Kod);
      if(Up2 || Dn2) sem = CharToStr(Symbol_2_Kod);
      if(Up3 || Dn3) sem = CharToStr(Symbol_3_Kod);
   }
   label = TAG+"ZIP";
   ObjectCreate(label,OBJ_LABEL,0,0,0);
   ObjectSetText(label,msg,INPLAYFontSize,INPLAYFont,msgcolor); 
   ObjectSet(label, OBJPROP_CORNER, INPLAYcorner );
   ObjectSet(label,OBJPROP_XDISTANCE,INPLAYx+1.5*INPLAYFontSize);
   ObjectSet(label,OBJPROP_YDISTANCE,INPLAYy+1);
   ObjectSet(label,OBJPROP_BACK, false);
   label = TAG+"ZIPSEM";
   ObjectCreate(label,OBJ_LABEL,0,0,0);
   ObjectSetText(label, sem , 1.1*INPLAYFontSize , "Wingdings",  msgcolor );
   ObjectSet(label, OBJPROP_CORNER, INPLAYcorner);
   ObjectSet(label, OBJPROP_XDISTANCE, INPLAYx );
   ObjectSet(label, OBJPROP_YDISTANCE, INPLAYy+1 );
   ObjectSet(label, OBJPROP_BACK, false);
   
   if (DropShadows && ObjectFind(TAG+"legend.A") != 0)
   {
      int x,y;
      x= ShadowDepth;
      y=ShadowDepth;
      DrawCell(0, TAG+"IP.A", INPLAYx-8+ShadowDepth, INPLAYy-12+ShadowDepth, 279, 48, shadow_color,INPLAYcorner);
   }
   if (ObjectFind(TAG+"IP.border") != 0) DrawCell(0, TAG+"legend.border", INPLAYx-8, INPLAYy-12, 279, 48, border_color,INPLAYcorner);
   if (ObjectFind(TAG+"IP.box") != 0) DrawCell(0, TAG+"legend.box", INPLAYx+2-8, INPLAYy+1-11, 279, 45, cell_color,INPLAYcorner);
   
}

void DrawCell(int nWindow, string nCellName, double nX, double nY, double nWidth, double nHeight, color nColor, int cnr)
{
   double   iHeight, iWidth, iXSpace;
   int      iSquares, i;
   
   if(nWidth > nHeight)
   {
     iSquares = MathCeil(nWidth/nHeight);      // Number of squares used.
     iHeight  = MathRound((nHeight*100)/111);   // Real height size.
     iWidth   = MathRound((nWidth*100)/111);    // Real width size.
     iXSpace  = iWidth/iSquares - ((iHeight/(9-(nHeight/100)))*2);
     
      for(i=0;i<iSquares;i++)
      {
         ObjectCreate   (nCellName+i, OBJ_LABEL,nWindow,0,0);
         ObjectSetText  (nCellName+i, CharToStr(110),iHeight, "Wingdings", nColor);
         ObjectSet      (nCellName+i, OBJPROP_XDISTANCE,nX + iXSpace*i);
         ObjectSet      (nCellName+i, OBJPROP_YDISTANCE,nY);    
//         ObjectSet      (nCellName+i, OBJPROP_BACK, true);
         ObjectSet      (nCellName+i, OBJPROP_BACK, false);
         ObjectSet      (nCellName+i, OBJPROP_CORNER, cnr);
      }        
   }else{
      iSquares = MathCeil(nHeight/nWidth);      // Number of squares used.
      iHeight  = MathRound((nHeight*100)/77);   // Real height size.
      iWidth   = MathRound((nWidth*100)/77);    // Real width size.
      iXSpace  = iHeight/iSquares - ((iWidth/(9-(nWidth/100)))*2);   
 
      for(i=0;i<iSquares;i++)
      {
         ObjectCreate   (nCellName+i, OBJ_LABEL,nWindow,0,0);
         ObjectSetText  (nCellName+i, CharToStr(110),iWidth, "Wingdings", nColor);
         ObjectSet      (nCellName+i, OBJPROP_XDISTANCE,nX);
         ObjectSet      (nCellName+i, OBJPROP_YDISTANCE,nY + iXSpace*i);    
//         ObjectSet      (nCellName+i, OBJPROP_BACK, true);
         ObjectSet      (nCellName+i, OBJPROP_BACK, false);
         ObjectSet      (nCellName+i, OBJPROP_CORNER, cnr);
      }       
   }
}

